function [pars_hat,yyhat] = FitInitialGuess(XX,yy,Model)  

ss = XX(:,1);
xx = XX(:,3);

yyhat_fun = @(pars)[ -Model.ratefun(ss,pars(3:end)).*xx  +Model.ratefun(ss,pars(3:end)).*xx  Model.ratefun(ss,pars(3:end)).*xx*pars(1)-pars(2)*xx ];

residuals = @(pars) yy(:)-reshape(yyhat_fun(pars),[],1)  ;
    
[p0,lb,ub] = DefineParameterBoundsLibrary ;

% case 'lsqnonlin'
options = optimset('TolX',1e-8,'TolFun',1e-8,'MaxFunEvals',2000);%,'Display','iter');

[pars_hat] = lsqnonlin(@(p) residuals(p),p0,lb,ub,options);

yyhat =     yyhat_fun(pars_hat);
% return



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [p0,lb,ub] = DefineParameterBoundsLibrary

ModelName = Model.name;

switch ModelName
    case 'Monod'
        lb = [0 0 1 1e-16];
        ub = [1 1 100 10];
    case 'Tessier'
        lb = [0 0 0 1e-16];
        ub = [1 1 100 10];
end

p0 = 0.5*(ub-lb);
        
end



end

