function [pars_out,model_out] = FitSCSNonlinDirect(XX,yy,OptimFun,model,x0,A,b,Aeq,beq)

ss = XX(:,1);
xx = XX(:,3);        

residuals = @(pars) yy(:)-reshape(yyhat_fun(pars),[],1)  ;
        
lb = [zeros(1,2) -1e3*ones(1,length(model.x)) ];
ub = [ones(1,2) 1e3*ones(1,length(model.x)) ];
p0 = [0.5*ones(1,2) x0'];

options = optimset('TolX',1e-8,'TolFun',1e-8,'MaxFunEvals',2000);%,'Display','iter');

options_fmincon = optimoptions('fmincon');
options_fmincon.Display = 'off';
options_fmincon.TolX = 1e-6;
options_fmincon.TolFun = 1e-6;

pars_out  = lsqnonlin(@(p) residuals(p),p0,lb,ub,options);
model_out   = model;
model_out.x = pars_out(3:end)';

% yyhat =     yyhat_fun(pars_hat);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [yyhat_out] = yyhat_fun(p)

% AM: the use of fmincon within this residuals function is not good,
% because it changes the value of p! This value is never communicated back
% to the optimizer, but it does affect the calculations of the residuals.
% This connects wrong residuals to wrong p values.
x1 = fmincon(@(x) OptimFun(x),p(3:end)',A,b,Aeq,beq,[],[],[],options_fmincon);
model.x = x1;
rate = EvalDynSCS(model,ss,0);
    
yyhat_out = [ -rate.*xx  +rate.*xx  rate.*xx*p(1)-p(2)*xx ];    
    
end   


end