function [pars_out,model_out] = FitSCSNonlinIndirect(t,C,OptimFun,model,x0,A,b,Aeq,beq,SFP)

% OptimFun is the function that goes into fmincon to find the best SCS
% parameters
        

residuals = @(pars) C(:)-reshape(C_fun(pars),[],1)  ;
        
lb = [zeros(1,2) -1e3*ones(1,length(model.x)) ];
ub = [ones(1,2) 1e3*ones(1,length(model.x)) ];
p0 = [0.5*ones(1,2) x0];

options = optimset('TolX',1e-8,'TolFun',1e-8,'MaxFunEvals',2000);%,'Display','iter');

options_fmincon = optimoptions('fmincon');
options_fmincon.Display = 'final';
options_fmincon.TolX = 1e-6;
options_fmincon.TolFun = 1e-6;

pars_out  = lsqnonlin(@(p) residuals(p),p0,lb,ub,options);
model_out   = model;
model_out.x = pars_out(3:end)';

% yyhat =     yyhat_fun(pars_hat);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [Chat] = C_fun(p)

% AM: the use of fmincon within this residuals function is not good,
% because it changes the value of p! This value is never communicated back
% to the optimizer, but it does affect the calculations of the residuals.
% This connects wrong residuals to wrong p values.
    
x1 = fmincon(@(x) OptimFun(x),p(3:end),A,b,Aeq,beq,[],[],[],options_fmincon);
model.x = x1;
[~,Chat] = EvaluateODE(t,[ SFP.S0 ; SFP.X0 ],model,C,[],SFP,'SCS') ;
   
    
end   


end